rm(list=ls())

if(!require(RODBC)) install.packages("RODBC", dep=T); require(RODBC)
if(!require(lubridate)) install.packages("lubridate", dep=T); require(lubridate)
if(!require(reshape)) install.packages("reshape", dep=T); require(reshape)
#if(!require(plyr)) install.packages("plyr", dep=T); require(plyr)
if(!require(logcondens.mode)) install.packages("logcondens.mode", dep=T); require(logcondens.mode)
if(!require(pastecs)) install.packages("pastecs", dep=T); require(pastecs)
if(!require(dplyr)) install.packages("dplyr", dep=T); require(dplyr)
if(!require(reshape)) install.packages("reshape", dep=T); require(reshape)
if(!require(readxl)) install.packages("readxl", dep=T); require(readxl)
if(!require(stringr)) install.packages("stringr", dep=T); require(stringr)
if(!require(readxl)) install.packages("readxl", dep=T); require(readxl)
if(!require(data.table)) install.packages("data.table", dep=T); require(data.table)
if(!require(matrixStats)) install.packages("matrixStats", dep=T); require(matrixStats)


# INSERIR O ANO DE REFERNCIA 
ano <- 2022

#LOCAL ONDE EST A BASE BAIXADA
setwd("####")

#Escolha o ano
base<-read.csv2("pls_totais_R_400.csv",header=TRUE,stringsAsFactors = FALSE)

#Trabalhe apenas com os dados anuais
base<-base[base$periodicidade=="Anual"&base$ano==ano,]
  
#Temos que tirar alguns tribunais para o clculo
sai.trib<-c("TRE","TJ","TRF1_2 Grau", "TRF2_2 Grau","TRF3_2 Grau",
              "TRF4_2 Grau","TRF5_2 Grau","TRF6_2 Grau","TRF1_SJAM","TRF2_SJRJ","TRF4_SJSC", "TRF4_SJPR","TRF4_SJRS","TRF1_SJAC",
              "TRF1_SJAP","TRF1_SJBA","TRF1_SJDF","TRF1_SJRR","TRF1_SJRO","TRF1_SJPI","TRF1_SJMG","TRF1_SJMT",
              "TRF1_SJMA","TRF1_SJGO","TRF1_SJTO","TRF5_SJAL","TRF5_SJSE","TRF5_SJPE","TRF5_SJCE","TRF5_SJRN",
              "TRF5_SJPB","TRF2_SJES","TRF3_SJSP","TRF3_SJMS","TRF","TJM","PJ","TRT","Sup/Con","TRF1_SJPA","TRF6")
base<-base[!base$tribunal %in% sai.trib,]
  
 
  
base$cee<-gsub(pattern=",",replacement = ".",base$cee) #Consumo de energia
base$ca<-gsub(pattern=",",replacement = ".",base$ca)   #Consumo de gua
base$ftt<-gsub(pattern=",",replacement = ".",base$ftt) #Fora de Trabalho Total
base$qve<-gsub(pattern=",",replacement = ".",base$qve) #Quantidade de Veculos
base$cc<-gsub(pattern=",",replacement = ".",base$cc) #Consumo de copos descartveis per capita
base$gcm<-gsub(pattern=",",replacement = ".",base$gcm) #Gasto com contratos de motoristas
base$gmv<-gsub(pattern=",",replacement = ".",base$gmv) #Gasto com manuteno de veculos
base$gcv<-gsub(pattern=",",replacement = ".",base$gcv) #Gasto com contratos de agenciamento de transporte terrestre
base$gc<-gsub(pattern=",",replacement = ".",base$gc)   #Gasto com combustveis
base$gcgraf<-gsub(pattern=",",replacement = ".",base$gcgraf) #Gastos com servios grficos no perodo-base
base$gpp<-gsub(pattern=",",replacement = ".",base$gpp) #Gasto com papel prprio
base$tmr<-gsub(pattern=",",replacement = ".",base$tmr) #Total de materiais destinados  reciclagem
base$ced.ftt<-gsub(pattern=",",replacement = ".",base$ced.ftt) #Consumo de embalagens descartveis para gua mineral per capita
base$gtf<-gsub(pattern=",",replacement = ".",base$gtf) #Gasto com telefonia fixa
base$gtm<-gsub(pattern=",",replacement = ".",base$gtm) #Gasto com telefonia mvel
base$qei<-gsub(pattern=",",replacement = ".",base$qei) #Quantidade de equipamentos de impresso 

#Variveis
#1 - cre - Consumo de energia per capita
base$cee<-as.numeric(base$cee)
base$ftt<-as.numeric(base$ftt)
base$cre<-base$cee/base$ftt

#2 - cra - Consumo de gua per capita
base$ca<-as.numeric(base$ca)
base$cra<-base$ca/base$ftt

#3 - upv - Usurio por veculo 
base$qve<-as.numeric(base$qve)
base$upv<-ifelse(base$qve==0,NA,base$ftt/base$qve)

#4 - cc.ftt - Consumo de copos descartveis per capita
base$cc<-as.numeric(base$cc)
base$cc.ftt<-base$cc/base$ftt
#5 - gtrans.ftt - Gasto com transporte per capita
base$gcm<-as.numeric(base$gcm)
base$gmv<-as.numeric(base$gmv)
base$gcv<-as.numeric(base$gcv)
base$gc<-as.numeric(base$gc)
base$gtrans.ftt<-(base$gcm+base$gmv+base$gcv+base$gc)/base$ftt

#6 - gp.ftt - Gastos de papel per capita
base$gcgraf<-as.numeric(base$gcgraf)
base$gpp<-as.numeric(base$gpp)
base$gp.ftt<-(base$gcgraf+base$gpp)/base$ftt

#7 - tmr.ftt - Destinao de material para reciclagem per capita
base$tmr<-as.numeric(base$tmr)
base$tmr.ftt<-base$tmr/base$ftt

#8 - ced.ftt - Consumo de gua envasada descartvel per capita
base$ced.ftt<-as.numeric(base$ced.ftt)

#9 - glinha - Gasto de Telefonia per capita
base$gtf<-as.numeric(base$gtf)
base$gtm<-as.numeric(base$gtm)
base$glinha.ftt<-(base$gtf+base$gtm)/base$ftt

#10 - qet.ftt - Quantidade de equipamentos de impresso per capita
base$qei<-as.numeric(base$qei)
base$qei.ftt<-base$qei/base$ftt

  
  
  
#Padronizando pela distribuio uniforme
base$uni_cre<-1-(base$cre - min(base$cre,na.rm=TRUE))/(max(base$cre,na.rm=TRUE)-min(base$cre,na.rm=TRUE))
base$uni_cra<-1-(base$cra - min(base$cra,na.rm=TRUE))/(max(base$cra,na.rm=TRUE)-min(base$cra,na.rm=TRUE))
base$uni_upv<-(base$upv - min(base$upv,na.rm=TRUE))/(max(base$upv,na.rm=TRUE)-min(base$upv,na.rm=TRUE)) #INVERTIDO
base$uni_cc.ftt<-1-(base$cc.ftt - min(base$cc.ftt,na.rm=TRUE))/(max(base$cc.ftt,na.rm=TRUE)-min(base$cc.ftt,na.rm=TRUE))
base$uni_gtrans.ftt<-1-(base$gtrans.ftt - min(base$gtrans.ftt,na.rm=TRUE))/(max(base$gtrans.ftt,na.rm=TRUE)-min(base$gtrans.ftt,na.rm=TRUE))
base$uni_gp.ftt<-1-(base$gp.ftt - min(base$gp.ftt,na.rm=TRUE))/(max(base$gp.ftt,na.rm=TRUE)-min(base$gp.ftt,na.rm=TRUE))
base$uni_tmr.ftt<-(base$tmr.ftt - min(base$tmr.ftt,na.rm=TRUE))/(max(base$tmr.ftt,na.rm=TRUE)-min(base$tmr.ftt,na.rm=TRUE)) #INVERTIDO
base$uni_ced.ftt<-1-(base$ced.ftt - min(base$ced.ftt,na.rm=TRUE))/(max(base$ced.ftt,na.rm=TRUE)-min(base$ced.ftt,na.rm=TRUE))
base$uni_glinha.ftt<-1-(base$glinha.ftt - min(base$glinha.ftt,na.rm=TRUE))/(max(base$glinha.ftt,na.rm=TRUE)-min(base$glinha.ftt,na.rm=TRUE))
base$uni_qei.ftt<-1-(base$qei.ftt - min(base$qei.ftt,na.rm=TRUE))/(max(base$qei.ftt,na.rm=TRUE)-min(base$qei.ftt,na.rm=TRUE))

  
#Pesos da AHP
pesos<-c(
  1.93704545454545, #Consumo de energia per capita
  1.93704545454545, #Consumo de agua per capita
  0.644469696969697, #Usurio por veculo
  1.14227272727273, #Consumo de copos descartveis per capita
  0.644469696969697, #Gasto com transporte per capita
  1.14227272727273, #Gasto de papel per capita
  0.644469696969697, #Destinao de material para reciclagem per capita
  1.14227272727273, #Consumo de gua envasada descartvel per capita
  0.382840909090909 ,#Gastos de Telefonia per capita
  0.382840909090909  #Quantidade de equipamentos de impresso per capita
  )
  
#Calcula-se o IDS para todos os tribunais
base$ids<-(base$uni_cre*pesos[1]+
                 base$uni_cra*pesos[2]+
                 base$uni_upv*pesos[3]+
                 base$uni_cc.ftt*pesos[4]+
                 base$uni_gtrans.ftt*pesos[5]+
                 base$uni_gp.ftt*pesos[6]+
               base$uni_tmr.ftt*pesos[7]+
                 base$uni_ced.ftt*pesos[8]+
                 base$uni_glinha.ftt*pesos[9]+
                 base$uni_qei.ftt*pesos[10])/sum(pesos)
  
  
  
var<-c("uni_cre","uni_cra","uni_upv","uni_cc.ftt","uni_gtrans.ftt","uni_gp.ftt","uni_tmr.ftt","uni_ced.ftt","uni_glinha.ftt","uni_qei.ftt")

baseids<-base[,c("tribunal","ids",var)]

write.csv2(baseids,"Resultado IDS - 2022.csv",row.names = FALSE)

